var rainbowDash = require('../lib/rainbow-dash');

/* jshint maxparams: 5 */
function naiveInterpolation(x1, y1, x2, y2, x) {
    if(x <= x1) return y1;
    if(x >= x2) return y2;
    var rgb1 = y1.match(/[0-9]+/g).map(Number);
    var rgb2 = y2.match(/[0-9]+/g).map(Number);
    var rgb = rgb1.map(function(rgb1Val, i) {
        return ((rgb2[i] - rgb1[i])/(x2 - x1))*x + ((x2*rgb1[i] - x1*rgb2[i])/(x2 - x1));
    });
    return 'rgb(' + rgb[0] + ',' + rgb[1] + ',' + rgb[2] + ')';
}

exports.naivePerf = function(test) {
    var ops = 100000;
    var startTime = Date.now();
    for(var i = 0; i < ops; i++) {
        naiveInterpolation(0, 'rgb(0,0,0)', ops, 'rgb(255,255,255)', i);
    }
    var endTime = Date.now();
    console.log((endTime - startTime) + 'ms, ' + (ops / (endTime - startTime) * 1000) + ' ops/sec');
    test.done();
};

exports.nodePerf = function(test) {
    var ops = 1000000;
    var range = {};
    range[0] = 'rgb(0,0,0)';
    range[ops] = 'rgb(255,255,255)';
    var gradient = rainbowDash(range);
    var startTime = Date.now();
    for(var i = 0; i < ops; i++) {
        gradient(i);
    }
    var endTime = Date.now();
    console.log((endTime - startTime) + 'ms, ' + (ops / (endTime - startTime) * 1000) + ' ops/sec');
    test.done();
};
