var rainbowDashTests = require('./test');
var jscoverage = require('jscoverage');
var coveralls = require('coveralls');
jscoverage.enableCoverage(true);
var rainbowDash = jscoverage.require(module, '../lib/rainbow-dash');

rainbowDashTests.injectObjs({
    logger: console.log,
    rainbowDash: rainbowDash
});

for(var test in rainbowDashTests) {
    if(['injectObjs', 'naivePerf', 'perf'].indexOf(test) === -1 && rainbowDashTests.hasOwnProperty(test)) exports[test] = rainbowDashTests[test];
}

exports.jscoverage = function(test) {
    test.expect(1);
    jscoverage.coverageDetail();
    var coverageStats = jscoverage.coverageStats();
    Object.keys(coverageStats).forEach(function(file) {
        test.equal(coverageStats[file].total, coverageStats[file].touched, 'All lines of code exercised by the tests');
    });
    if(process.env.TRAVIS) coveralls.handleInput(jscoverage.getLCOV());
    test.done();
};